//---------------------------------------------------------------------------
#include <vcl.h>
#include <shellapi.h>
#include <shlobj.h>
#include <dbt.h>
#include "inifiles.hpp"
#include "FileCtrl.hpp"
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

AnsiString IconText=" USB ";
int WHide=1;
int WClose=0;
int FindUSB=0;
int FindAUTO=0;
AnsiString DriveArray="ABCDEFGHIJKLMNOPQRSTUVWXYZ";
TStrings * DriveList = new TStringList();
TStrings * DriveLabel = new TStringList();
TIniFile *Ini; // Ini-

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
int TForm1::ReReadDrive(int force){

        TStrings * NewDriveList = new TStringList();
        TStrings * NewDriveLabel = new TStringList();
        NewDriveList->Clear();
        NewDriveLabel->Clear();


        int usbcount=0;
          AnsiString CurDrive="";
          char lpVolumeNameBuffer[255];
          DWORD lpVolumeSerialNumber;
          char lpFileSystemNameBuffer[255];

    for (int i=3; i<=DriveArray.Length(); i++){
       CurDrive=(AnsiString)DriveArray[i]+":\\";
       if (GetDriveType(CurDrive.c_str()) == DRIVE_REMOVABLE || (GetDriveType(CurDrive.c_str()) ==DRIVE_CDROM && CheckBox4->Checked==true)) {
       //if (GetDriveType(CurDrive.c_str()) == DRIVE_FIXED ) {
          BOOL InfoDrive = GetVolumeInformation(
            CurDrive.c_str(),	// address of root directory of the file system
            lpVolumeNameBuffer,	// address of name of the volume
            sizeof(lpVolumeNameBuffer),	// length of lpVolumeNameBuffer
            &lpVolumeSerialNumber,	// address of volume serial number
            NULL,	// address of system's maximum filename length
            NULL,	// address of file system flags
            lpFileSystemNameBuffer,	// address of name of file system
            sizeof(lpFileSystemNameBuffer) 	// length of lpFileSystemNameBuffer
          );

           if (InfoDrive !=0){
((AnsiString)lpVolumeSerialNumber, 0),8));
                if (GetDriveType(CurDrive.c_str())==DRIVE_CDROM){
                  if (CheckBox4->Checked==true){
                   NewDriveList->Add(CurDrive+"  [CD/DVD]=<"+Trim((AnsiString)lpVolumeNameBuffer)+">  "+Trim((AnsiString)lpFileSystemNameBuffer)+"  ("+IntToHex(StrToIntDef((AnsiString)lpVolumeSerialNumber, 0),8)+")");
                   NewDriveLabel->Add(CurDrive);
                  }
                }else{
                  NewDriveList->Add(CurDrive+"  <"+Trim((AnsiString)lpVolumeNameBuffer)+">  "+Trim((AnsiString)lpFileSystemNameBuffer)+"  ("+IntToHex(StrToIntDef((AnsiString)lpVolumeSerialNumber, 0),8)+")");
                  NewDriveLabel->Add(CurDrive);
                }

           }
       }
    }

    if (NewDriveList->Text!=DriveList->Text || force==1){
        FindUSB=0;
        FindAUTO=0;
        // 
        DriveList->Clear();
        DriveLabel->Clear();
        DriveList->Text=NewDriveList->Text;
        DriveLabel->Text=NewDriveLabel->Text;

        if (NewDriveLabel->Count==0) {
                IconText=" USB ";
        }else{
          if (CheckBox4->Checked==true){
                usbcount=0;                
                for (int j=0; j<NewDriveList->Count; j++){
                     if ((NewDriveList->Strings[j]).Pos("  [CD/DVD]=<")==0) usbcount++;
                }
                if (usbcount>0)  IconText=" "+IntToStr(usbcount)+"  ";
                FindUSB=usbcount;
          }else{
                if (NewDriveLabel->Count>0)  IconText=" "+IntToStr(NewDriveLabel->Count)+"  ";
                FindUSB=NewDriveLabel->Count;
          }

        }

        for (int j=0; j<PopupMenu2->Items->Count; j++){
             PopupMenu2->Items->Items[j]->Visible=false;
        }
        for (int j=0; j<NewDriveList->Count; j++){
             PopupMenu2->Items->Items[j]->Caption=NewDriveList->Strings[j];
             PopupMenu2->Items->Items[j]->Visible=true;
             if ((NewDriveList->Strings[j]).Pos("  [CD/DVD]=<")!=0){
                if (FileExists(NewDriveLabel->Strings[j])+"autorun.inf"){
                    PopupMenu2->Items->Items[j]->Bitmap=Image6->Picture->Bitmap;
                }else{
                    PopupMenu2->Items->Items[j]->Bitmap=Image5->Picture->Bitmap;
                }
             }else{
                if (DirectoryExists(NewDriveLabel->Strings[j]+"autorun.inf")){
                    PopupMenu2->Items->Items[j]->Bitmap=Image8->Picture->Bitmap;
                }else if (FileExists(NewDriveLabel->Strings[j]+"autorun.inf")){
                    PopupMenu2->Items->Items[j]->Bitmap=Image9->Picture->Bitmap;
                    FindAUTO=1;
                }else{
                    PopupMenu2->Items->Items[j]->Bitmap=Image7->Picture->Bitmap;
                }
             }
        }
    }
    TrayMessage(NIM_ADD);
    TrayMessage(NIM_MODIFY);
    delete NewDriveList;
    delete NewDriveLabel;
    return 0;
};
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::MyNotify(TMessage& Msg)
{
    POINT MousePos;
    switch(Msg.LParam)
    {
        case WM_RBUTTONUP:
            if (GetCursorPos(&MousePos))
            {
                PopupMenu1->PopupComponent = Form1;
                SetForegroundWindow(Handle);
                PopupMenu1->Popup(MousePos.x, MousePos.y);
            }
            break;
        case WM_LBUTTONUP:
            if (GetCursorPos(&MousePos))
            {
                PopupMenu2->PopupComponent = Form1;
                SetForegroundWindow(Handle);
                PopupMenu2->Popup(MousePos.x, MousePos.y);
            }
            break;
        default:
            break;
    }
    TForm::Dispatch(&Msg);
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::DrawItem(TMessage& Msg)
{
     IconDrawItem((LPDRAWITEMSTRUCT)Msg.LParam);
     TForm::Dispatch(&Msg);
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
LRESULT IconDrawItem(LPDRAWITEMSTRUCT lpdi)
{
	HICON hIcon;
        //HINSTANCE hinst;

	hIcon = (HICON)LoadImage(NULL, MAKEINTRESOURCE(lpdi->CtlID), IMAGE_ICON,
		16, 16, 0);
	if (!hIcon)
		return(FALSE);

	DrawIconEx(lpdi->hDC, lpdi->rcItem.left, lpdi->rcItem.top, hIcon,
		16, 16, 0, NULL, DI_NORMAL);

	return(TRUE);
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
bool __fastcall TForm1::TrayMessage(DWORD dwMessage)
{
   NOTIFYICONDATA tnd;
   PSTR pszTip;

   pszTip = IconText.c_str();

   tnd.cbSize          = sizeof(NOTIFYICONDATA);
   tnd.hWnd            = Handle;
   tnd.uID             = IDC_MYICON;
   tnd.uFlags          = NIF_MESSAGE | NIF_ICON | NIF_TIP;
   tnd.uCallbackMessage	= MYWM_NOTIFY;

   if (dwMessage == NIM_MODIFY)
    {
        tnd.hIcon		= (HICON)IconHandle();
        if (pszTip)
           lstrcpyn(tnd.szTip, pszTip, sizeof(tnd.szTip));
	    else
        tnd.szTip[0] = '\0';
    }
   else if (dwMessage == NIM_DELETE)
    {
        tnd.hIcon = NULL;
        tnd.szTip[0] = '\0';
        //ShowMessage("");
    }
   else
    {
        tnd.hIcon = NULL;
        tnd.szTip[0] = '\0';
    }

   return (Shell_NotifyIcon(dwMessage, &tnd));
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
HICON __fastcall TForm1::IconHandle(void)
{
        if (FindUSB==0)
        {
                    if (ComboBox1->ItemIndex==0){
                          return (Image1->Picture->Icon->Handle);
                    }else if (ComboBox1->ItemIndex==1){
                          return (Image2->Picture->Icon->Handle);
                    }else if (ComboBox1->ItemIndex==2){
                          return (Image11->Picture->Icon->Handle);
                    }


        }else{
           if (FindAUTO==0){
                    if (ComboBox1->ItemIndex==0){
                          return (Image2->Picture->Icon->Handle);
                    }else if (ComboBox1->ItemIndex==1){
                          return (Image10->Picture->Icon->Handle);
                    }else if (ComboBox1->ItemIndex==2){
                          return (Image10->Picture->Icon->Handle);
                    }


           }else{
                  return (Image4->Picture->Icon->Handle);
           }
        }
        //return (Image2->Picture->Icon->Handle);
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------


void __fastcall TForm1::N1Click(TObject *Sender)
{
        if (MessageDlg(" ?", mtConfirmation, TMsgDlgButtons() << mbYes << mbNo, 0)==mrYes){
                Form1->Close();
        }


}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckItem(TObject *Sender)
{
        ReadINI();
        WHide=0;
        Form1->Left=Screen->Width/2-Form1->Width/2;
        Form1->Top=Screen->Height/2-Form1->Height/2;
        Form1->Show();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::FormCreate(TObject *Sender)
{
     HANDLE hMutex = CreateMutex (NULL, TRUE, "Unique_Flag_for_my_mini_USB_programm");
     if (GetLastError() == ERROR_ALREADY_EXISTS)
     {
              CloseHandle(hMutex);
              WClose=1;
     }else{

        ComboBox1->ItemIndex=0;

        AnsiString IniP=ExtractFilePath(Application->ExeName);
        if (FileExists(IniP+"main_usb_viewer.ini")){
           IniP=IniP+"main_";
        }else{
                OSVERSIONINFO ver_info;
                ver_info.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
                GetVersionEx(&ver_info);

                if (ver_info.dwPlatformId == VER_PLATFORM_WIN32_NT){
                        ITEMIDLIST * List;
                        char folder[MAX_PATH];
                        if (SHGetSpecialFolderLocation(0, CSIDL_APPDATA, &List)==NOERROR){
                                if (SHGetPathFromIDList(List, folder)==TRUE){
                                   if (  DirectoryExists( Trim((AnsiString)folder) )  ){ IniP=Trim((AnsiString)folder);}
                                }
                        }
                }

                if (IniP.SubString(IniP.Length(), 1)!="\\") IniP=IniP+"\\";
                if (ParamCount()>0){
                        if (LowerCase(ParamStr(1)) == "for-all-with-main") {
                                IniP=ExtractFilePath(Application->ExeName);
                                IniP=IniP+"main_";
                        };
                }

        }
        Ini = new TIniFile(IniP+"usb_viewer.ini"); // Ini-
        ReadINI();


        HWND hWnd = Form1->Handle;
        HMENU hMenu = GetSystemMenu(hWnd, false);
        if (hMenu)
        {
        	EnableMenuItem(hMenu, SC_CLOSE, MF_GRAYED);
		DeleteMenu(hMenu, SC_CLOSE, MF_BYCOMMAND);
        }
        TrayMessage(NIM_ADD);
        TrayMessage(NIM_MODIFY);
        Form1->Left=-20-Form1->Width;
        Form1->Top=-20-Form1->Height;

        SetWindowLong(Application->Handle, GWL_EXSTYLE, GetWindowLong(Application->Handle,GWL_EXSTYLE) | WS_EX_TOOLWINDOW);
        ReReadDrive(0);

        if (ParamCount()>0){
                if (LowerCase(ParamStr(1)) == "autorun") AutoRun(0);
                if (LowerCase(ParamStr(1)) == "for-all") AutoRun(1);
                if (LowerCase(ParamStr(1)) == "for-all-with-main") AutoRun(2);
        }
     };
}
//---------------------------------------------------------------------------



void __fastcall TForm1::FormPaint(TObject *Sender)
{
         if (WHide==1) {
           Form1->Hide();
         }
         if (WClose==1) {
           Form1->Close();
         }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton2Click(TObject *Sender)
{
        WHide=1;
        if (WClose==2) Form1->Close();
        Form1->Hide();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton1Click(TObject *Sender)
{
        WHide=1;
        WriteINI();

        if (WClose==2) {
                if (MessageDlg("   ''?", mtConfirmation, TMsgDlgButtons() << mbYes << mbNo, 0)==mrYes){Ini->WriteString("Main","DisEx","1");};
                if (MessageDlg("    ?", mtConfirmation, TMsgDlgButtons() << mbYes << mbNo, 0)==mrYes){Ini->WriteString("Main","DisWr","1");};
                if (MessageDlg("   ?", mtConfirmation, TMsgDlgButtons() << mbYes << mbNo, 0)==mrYes){Ini->WriteString("Main","DisCl","1");};
                Form1->Close();
        };
        Form1->Hide();
        TrayMessage(NIM_MODIFY);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
    	TrayMessage(NIM_DELETE);
}
//---------------------------------------------------------------------------

    void __fastcall TForm1::WndProc(Messages::TMessage &Message){

        if (Message.Msg == WM_DEVICECHANGE && Message.WParam==DBT_DEVICEARRIVAL)   {
                //ResetEvent(eDeviceEvent);

                DEV_BROADCAST_HDR *header = (DEV_BROADCAST_HDR *) Message.LParam;
                if (header->dbch_devicetype == DBT_DEVTYP_VOLUME) {
                       PDEV_BROADCAST_HDR lpdb = (PDEV_BROADCAST_HDR)Message.LParam;
                       PDEV_BROADCAST_VOLUME lpdbv = (PDEV_BROADCAST_VOLUME)lpdb;
                       try{
                          int i=0;
                          for (i = 0; i < 26; ++i)
                          {
                              if (lpdbv ->dbcv_unitmask & 0x1)
                                break;
                              lpdbv ->dbcv_unitmask = lpdbv ->dbcv_unitmask >> 1;
                          }
                          if (lpdbv ->dbcv_flags & DBTF_MEDIA){
                                //ShowMessage("CD   "+(AnsiString)DriveArray[i+1]);
                                  if (CheckBox4->Checked==true) FindCD((AnsiString)DriveArray[i+1]+":\\");
                          }else{
                                //ShowMessage("   "+(AnsiString)DriveArray[i+1]);
                                  FindDisk((AnsiString)DriveArray[i+1]+":\\");
                          }

                          //FindDisk((AnsiString)DriveArray[i+1]+":\\");
                       }
                       catch (...){

                       }
                       ReReadDrive(0);
                       //ShowMessage("dd");  
                }

        }
        if (Message.Msg == WM_DEVICECHANGE && Message.WParam==DBT_DEVICEREMOVECOMPLETE)   {
                DEV_BROADCAST_HDR *header2 = (DEV_BROADCAST_HDR *) Message.LParam;
                if (header2->dbch_devicetype == DBT_DEVTYP_VOLUME) {
                       ReReadDrive(0);
                }

        }

        TForm::WndProc(Message);
    }
//---------------------------------------------------------------------------


void __fastcall TForm1::M26Click(TObject *Sender)
{
   AnsiString Name=((TMenuItem*)Sender)->Name, cmdline;
   int Number=StrToIntDef(Name.SubString(2, Name.Length()-1),0);
   if (Number>0){
     cmdline=Trim(DriveLabel->Strings[Number-1]);
     if (cmdline.Length()==3 && cmdline.SubString(2,2)==":\\"){
             cmdline=Zamena(Trim(Edit3->Text), "|D|", cmdline);
             try{
                     WinExec(cmdline.c_str(),SW_SHOW);
             }
             catch (...){
             }
     }
   }



}
//---------------------------------------------------------------------------

void __fastcall TForm1::N4Click(TObject *Sender)
{
        ReReadDrive(1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N5Click(TObject *Sender)
{
       ShowMessage("  \n  \n\n  :\n   autorun  -   \n   for-all  -      \n   for-all-with-main -     \n INI   ,     \n\nCopyLeft @ Yurii Suhanoff");
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
int TForm1::AutoRun(int i){

        ITEMIDLIST * List;
        char folder[MAX_PATH];
        WCHAR path[MAX_PATH];
        BOOL GETSF;
        if (i==1 || i==2){
                GETSF=SHGetSpecialFolderLocation(0, CSIDL_COMMON_STARTUP, &List);
        }else{
                GETSF=SHGetSpecialFolderLocation(0, CSIDL_STARTUP, &List);
        }
        if (GETSF==NOERROR){
             if (SHGetPathFromIDList(List, folder)==TRUE){
                  try{
                    CoInitialize(NULL);
                    IShellLink *SLink;
                    HRESULT HRes = CoCreateInstance(CLSID_ShellLink, 0, CLSCTX_INPROC_SERVER,
                    IID_IShellLink, ( LPVOID*)&SLink);
                    HRes = SLink->SetPath(Application->ExeName.c_str());//    ,    
                    HRes = SLink->SetWorkingDirectory(ExtractFilePath(Application->ExeName).c_str());//    
                    IPersistFile *PF;
                    HRes = SLink->QueryInterface(IID_IPersistFile, (LPVOID*)&PF);

                    lstrcat(folder, "\\");
                    lstrcat(folder, "usb_viewer.lnk");
                    MultiByteToWideChar(CP_ACP, 0, folder, -1, path, MAX_PATH);
                    HRes = PF->Save(path, TRUE);// 
                    SLink->Release();
                    CoUninitialize();
                    ShowMessage("   :\n"+(AnsiString) folder+"\n         ");
                  }
                  catch (...){
                        ShowMessage("   :\n"+(AnsiString) folder);
                  }

             }else{
                  ShowMessage("    (  )");
             }
        }else{
          ShowMessage("    ()");   
        }

        if (i==1) {
                WClose=1;
                Form1->Left=0;
                Form1->Top=0;
                Form1->Height=5;
                Form1->Width=5;
                Form1->Show();
        }
        if (i==2){
                WClose=2;
                CheckItem(this);
        }

    return 0;
};
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton3Click(TObject *Sender)
{
        AutoRun(0);
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
int TForm1::ReadINI(){
    AnsiString temp="";
    if (Ini->ReadString("Main","Act2","")!=""){Edit1->Text=Trim(Ini->ReadString("Main","Act2",""));};
    if (Ini->ReadString("Main","Act3","")!=""){Edit2->Text=Trim(Ini->ReadString("Main","Act3",""));};
    if (Ini->ReadString("Main","ManAct","")!=""){Edit3->Text=Trim(Ini->ReadString("Main","ManAct",""));};

    temp=Ini->ReadString("Main","Act1En","-1");
    if (Trim(temp)=="0") CheckBox1->Checked=false;
    if (Trim(temp)=="1") CheckBox1->Checked=true;

    temp="";
    temp=Ini->ReadString("Main","Act2En","-1");
    if (Trim(temp)=="0") CheckBox2->Checked=false;
    if (Trim(temp)=="1") CheckBox2->Checked=true;
    temp="";
    temp=Ini->ReadString("Main","Act3En","-1");
    if (Trim(temp)=="0") CheckBox3->Checked=false;
    if (Trim(temp)=="1") CheckBox3->Checked=true;

    temp="";
    temp=Ini->ReadString("Main","CdEn","-1");
    if (Trim(temp)=="0") CheckBox4->Checked=false;
    if (Trim(temp)=="1") CheckBox4->Checked=true;
    if (Ini->ReadString("Main","CdAct","")!=""){Edit4->Text=Trim(Ini->ReadString("Main","CdAct",""));};

    temp="";
    temp=Ini->ReadString("Main","Act4En","-1");
    if (Trim(temp)=="0") CheckBox5->Checked=false;
    if (Trim(temp)=="1") CheckBox5->Checked=true;

    temp="";
    temp=Ini->ReadString("Main","DisEx","-1");
    if (Trim(temp)=="1") N6->Visible=false;

    temp="";
    temp=Ini->ReadString("Main","IcoStyle","-1");
    if (Trim(temp)=="1") ComboBox1->ItemIndex=0;
    if (Trim(temp)=="2") ComboBox1->ItemIndex=1;
    if (Trim(temp)=="3") ComboBox1->ItemIndex=2;


    temp="";
    temp=Ini->ReadString("Main","Act5En","-1");
    if (Trim(temp)=="0") CheckBox6->Checked=false;
    if (Trim(temp)=="1") CheckBox6->Checked=true;

    temp="";
    temp=Ini->ReadString("Main","Act6En","-1");
    if (Trim(temp)=="0") CheckBox7->Checked=false;
    if (Trim(temp)=="1") CheckBox7->Checked=true;

    temp="";
    temp=Ini->ReadString("Main","DisWr","-1");
    if (Trim(temp)=="1") dd1->Visible=false;
    temp="";
    temp=Ini->ReadString("Main","DisCl","-1");
    if (Trim(temp)=="1") N1->Enabled=false;

    return 0;
};
//---------------------------------------------------------------------------
int TForm1::WriteINI(){
       //if (DisableWrite==1){
       //   ShowMessage("  INI  !");
       // }else{
            Ini->WriteString("Main","Act2",Edit1->Text);
            Ini->WriteString("Main","Act3",Edit2->Text);
            Ini->WriteString("Main","ManAct",Edit3->Text);

            if (CheckBox1->Checked==true){
                Ini->WriteString("Main","Act1En","1");
            }else{
                Ini->WriteString("Main","Act1En","0");
            }

            if (CheckBox2->Checked==true){
                Ini->WriteString("Main","Act2En","1");
            }else{
                Ini->WriteString("Main","Act2En","0");
            }

            if (CheckBox3->Checked==true){
                Ini->WriteString("Main","Act3En","1");
            }else{
                Ini->WriteString("Main","Act3En","0");
            }

            if (CheckBox4->Checked==true){
                Ini->WriteString("Main","CdEn","1");
            }else{
                Ini->WriteString("Main","CdEn","0");
            }
            Ini->WriteString("Main","CdAct",Edit4->Text);

            if (CheckBox5->Checked==true){
                Ini->WriteString("Main","Act4En","1");
            }else{
                Ini->WriteString("Main","Act4En","0");
            }

            if (CheckBox6->Checked==true){
                Ini->WriteString("Main","Act5En","1");
            }else{
                Ini->WriteString("Main","Act5En","0");
            }

            if (CheckBox7->Checked==true){
                Ini->WriteString("Main","Act6En","1");
            }else{
                Ini->WriteString("Main","Act6En","0");
            }

            if (ComboBox1->ItemIndex==0) Ini->WriteString("Main","IcoStyle","1");
            if (ComboBox1->ItemIndex==1) Ini->WriteString("Main","IcoStyle","2");
            if (ComboBox1->ItemIndex==2) Ini->WriteString("Main","IcoStyle","3");
       //}
    return 0;
};
//---------------------------------------------------------------------------
int TForm1::FindDisk(AnsiString MyDisk){
  AnsiString cmdline;
  AnsiString f1;
  AnsiString f2;
  AnsiString Path;
  HANDLE hFile;
  if (MyDisk.Length()==3 && MyDisk.SubString(2,2)==":\\"){
    if (CheckBox1->Checked==true){
            f1=MyDisk+"Autorun.inf";
            f2=MyDisk+"Autorun.#nf";
            if (FileExists(f1)) {
                try{
                  MoveFileExA((LPCTSTR)f1.c_str(), (LPCTSTR)f2.c_str(), (DWORD) MOVEFILE_REPLACE_EXISTING);
                }
                catch (...){
                }
            };
            Sleep(100);
    }

    if (CheckBox6->Checked==true){
            f1=MyDisk+"folder.htt";
            f2=MyDisk+"folder.#tt";
            if (FileExists(f1)) {
                try{
                  MoveFileExA((LPCTSTR)f1.c_str(), (LPCTSTR)f2.c_str(), (DWORD) MOVEFILE_REPLACE_EXISTING);
                }
                catch (...){
                }
            };
            Sleep(100);
    }

    if (CheckBox5->Checked==true){
       f1=MyDisk+"Autorun.inf";
       f2=MyDisk+"Autorun.#nf";
       if (FileExists(f1)) {
                try{
                  MoveFileExA((LPCTSTR)f1.c_str(), (LPCTSTR)f2.c_str(), (DWORD) MOVEFILE_REPLACE_EXISTING);
                }
                catch (...){
                }
       };
       Sleep(100);
       try{
           Path=MyDisk+"Autorun.inf";
           AnsiString PathF=Path+"\\LPT3.for_remove_read_kb_120716";
           AnsiString PathF2=Path+"\\read_me.txt";
           char buffer[2048];
           DWORD Writen = 0;
           wsprintf(buffer,"       kb 120716\r\nfor example,\r\nRD \\\\.\\g:\\autorun.inf /Q /S");

           if (!DirectoryExists(Path)){
                CreateDirectory(Path.c_str(), NULL);
                if (DirectoryExists(Path)){
                   SetFileAttributesA(
                     Path.c_str(),
                     FILE_ATTRIBUTE_HIDDEN+FILE_ATTRIBUTE_SYSTEM+FILE_ATTRIBUTE_READONLY
                   );
                }
           }
           if (DirectoryExists(Path)){
              if (!FileExists(PathF)){
                   hFile = CreateFile(PathF2.c_str(),GENERIC_WRITE,0,0, CREATE_ALWAYS, 0,0);
                   WriteFile(hFile,buffer,strlen(buffer),&Writen,0);
                   CloseHandle(hFile);
                   PathF="\\\\?\\"+PathF;
                   hFile = CreateFile(PathF.c_str(),GENERIC_WRITE,0,0, CREATE_ALWAYS,FILE_ATTRIBUTE_HIDDEN+FILE_ATTRIBUTE_SYSTEM,0);
                   CloseHandle(hFile);
              }
           }
       }catch (...){
       }
    }
    if (CheckBox7->Checked==true){
          Path=MyDisk+"RECYCLED";
          if (!DirectoryExists(Path) && !FileExists(Path)){
                   hFile = CreateFile(Path.c_str(),GENERIC_WRITE,0,0, CREATE_ALWAYS,FILE_ATTRIBUTE_HIDDEN+FILE_ATTRIBUTE_SYSTEM+FILE_ATTRIBUTE_READONLY,0);
                   CloseHandle(hFile);
          }
    }

    if (CheckBox2->Checked==true){
             cmdline=Zamena(Trim(Edit1->Text), "|D|", MyDisk);
             try{
                     WinExec(cmdline.c_str(),SW_SHOW);
             }        
             catch (...){
             }
            Sleep(500);
    }
    if (CheckBox3->Checked==true){
             cmdline=Zamena(Trim(Edit2->Text), "|D|", MyDisk);
             try{
                     WinExec(cmdline.c_str(),SW_SHOW);
             }
             catch (...){
             }
    }
  }//  if (MyDisk.Length()==3 && MyDisk.SubString(2,2)=":\\"){
  return 0;
};
//---------------------------------------------------------------------------
int TForm1::FindCD(AnsiString MyDisk){
  AnsiString cmdline;

  if (MyDisk.Length()==3 && MyDisk.SubString(2,2)==":\\"){
    if (CheckBox4->Checked==true){
             cmdline=Zamena(Trim(Edit4->Text), "|D|", MyDisk);
             try{

                     WinExec(cmdline.c_str(),SW_SHOW);
             }
             catch (...){
             }
    }
  }//  if (MyDisk.Length()==3 && MyDisk.SubString(2,2)=":\\"){
  return 0;
};
//---------------------------------------------------------------------------
AnsiString TForm1::Zamena(AnsiString str, AnsiString s1, AnsiString s2){
// 
    AnsiString Str2=str,StrMem;
    int step=0, findpos=0, mem=0;
    while (Str2.Pos(s1)>0 && step<100){
      step++;
      StrMem=str.SubString(findpos+Str2.Pos(s1)+s1.Length(),str.Length()-findpos-Str2.Pos(s1)+s1.Length());
      mem=Str2.Pos(s1)+s2.Length()-1;
      str=str.SubString(1, findpos+Str2.Pos(s1)-1)+s2+str.SubString(findpos+Str2.Pos(s1)+s1.Length(),str.Length()-findpos-Str2.Pos(s1)+s1.Length());
      Str2=StrMem;
      findpos+=mem;
    }
    return str;
};
//---------------------------------------------------------------------------

void __fastcall TForm1::N6Click(TObject *Sender)
{
   ReReadDrive(1);
   Form2->ComboBox1->Items->Clear();
   Form2->ComboBox2->Items->Clear();
   Form2->ComboBox1->Items->Text=DriveList->Text;
   Form2->ComboBox2->Items->Text=DriveLabel->Text;
   Form2->BitBtn1->Enabled=false;
   Form2->BitBtn2->Enabled=false;
   Form2->BitBtn3->Enabled=false;
   Form2->ComboBox1->ItemIndex=-1;
   Form2->ComboBox1->Text="-  -  -                     -  -  -";   
   Form2->Show();
}
//---------------------------------------------------------------------------

